#include<bits/stdc++.h>
#define M 500001
using namespace std;
inline int read()
{
	int k=0,f=0;char c=getchar();
	for(;!isdigit(c);c=getchar()) f|=c=='-';
	for(;isdigit(c);c=getchar()) k=(k<<1)+(k<<3)+(c^48);
	return f?-k:k;
}
int n,Q;
int h[M],cnt;
int fa[M],dep[M],siz[M],top[M],son[M],dep_max;
int st[M][20][2],LOG[M];
struct edge
{
	int to,ne;
}e[M<<1];
struct node
{
	int val,pos;
};
inline void add(int u,int v)
{
	cnt++,e[cnt].to=v,e[cnt].ne=h[u],h[u]=cnt;
	return;
}
inline void dfs1(int x,int father)
{
	fa[x]=father,dep[x]=dep[fa[x]]+1,siz[x]=1;
	dep_max=max(dep_max,dep[x]);
	for(int i=h[x];i;i=e[i].ne)
	{
		int y=e[i].to;
		if(y!=fa[x])
		{
			dfs1(y,x),siz[x]+=siz[y];
			if(siz[y]>siz[son[x]]) son[x]=y;
		}
	}
	return;
}
inline void dfs2(int x,int topx)
{
	top[x]=topx;
	if(!son[x]) return;
	dfs2(son[x],topx);
	for(int i=h[x];i;i=e[i].ne)
	{
		int y=e[i].to;
		if(y!=fa[x]&&y!=son[x]) dfs2(y,x);
	}
}
inline node ask(int x,int y)
{
	int K=LOG[y-x+1];
	node A;
	if(st[x][K][0]<st[y-(1<<K)+1][K][0]) A.val=st[x][K][0],A.pos=st[x][K][1];
	else A.val=st[y-(1<<K)+1][K][0],A.pos=st[y-(1<<K)+1][K][1];
	return A;
}
inline int dfs(int l,int r,int k)
{
	if(r-l+1<k) return 0;
	node A=ask(l,r);
	return max(A.val,min(dfs(l,A.pos-1,k),dfs(A.pos+1,r,k)));
}
inline void LIST()
{
	LOG[0]=-1;
	for(int i=1;i<=n;i++) st[i][0][0]=dep[i],st[i][0][1]=i,LOG[i]=LOG[i>>1]+1;
	for(int j=1;j<=19;j++)
	{
		for(int i=1;i+(1<<j)<=n;i++)
		{
			if(st[i][j-1][0]<st[i+(1<<(j-1))][j-1][0]) st[i][j][0]=st[i][j-1][0],st[i][j][1]=st[i][j-1][1];
			else st[i][j][0]=st[i+(1<<(j-1))][j-1][0],st[i][j][1]=st[i+(1<<(j-1))][j-1][1];
		}
	}
	Q=read();
	while(Q--)
	{
		int L=read(),R=read(),k=read();
		printf("%d\n",dfs(L,R,k));
	}
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	n=read();
	for(int i=1;i<n;i++)
	{
		int u=read(),v=read();
		add(u,v),add(v,u);
	}
	dfs1(1,0),dfs2(1,1);
	if(dep_max==n) LIST();
	return 0;
}

